#include "dyn_servos.h"

TDynReg ax_reg[NUM_REG]={// Info
                         {0x0000,2,1},
                         {0xFFFF,0,0},
                         {0x0002,1,1},
                         {0x0003,1,1},
                         {0x0004,1,1},
                         {0x0005,1,1},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         {0x0010,1,1},
                         // Configuration
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         {0x0006,2,1},
                         {0x0008,2,1},
                         {0x000B,1,1},
                         {0x000C,1,1},
                         {0x000D,1,1},
                         {0x000E,2,1},
                         {0x0022,2,0},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         // Status
                         {0x0011,1,1},
                         {0x0012,1,1},
                         {0x0019,1,0},
                         {0xFFFF,0,0},
                         {0x002E,1,0},
                         {0xFFFF,0,0},
                         {0x002F,1,0},
                         {0x002C,1,0},
                         {0xFFFF,0,0},
                         // Control 
                         {0x0018,1,0},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         {0x001A,1,0},
                         {0x001B,1,0},
                         {0x001C,1,0},
                         {0x001D,1,0},
                         {0x0030,2,0},
                         // Set point
                         {0x001E,2,0},
                         {0x0020,2,0},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         // Feedback
                         {0x0024,2,0},
                         {0x0026,2,0},
                         {0x0028,2,0},
                         {0x002A,1,0},
                         {0x002B,1,0},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0}};

TDynReg mx_1_0_reg[NUM_REG]={// Info
                         {0x0000,2,1},
                         {0xFFFF,0,0},
                         {0x0002,1,1},
                         {0x0003,1,1},
                         {0x0004,1,1},
                         {0x0005,1,1},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         {0x0010,1,1},
                         // Configuration
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         {0x0006,2,1},
                         {0x0008,2,1},
                         {0x000B,1,1},
                         {0x000C,1,1},
                         {0x000D,1,1},
                         {0x000E,2,1},
                         {0x0022,2,0},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         {0x0020,2,0},
                         {0x0014,2,1},
                         {0x0016,1,1},
                         // Status
                         {0x0011,1,1},
                         {0x0012,1,1},
                         {0x0019,1,0},
                         {0xFFFF,0,0},
                         {0x002E,1,0},
                         {0xFFFF,0,0},
                         {0x002F,1,0},
                         {0x002C,1,0},
                         {0xFFFF,0,0},
                         // Control 
                         {0x0018,1,0},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         {0x001C,1,0},
                         {0x001B,1,0},
                         {0x001A,1,0},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         {0x0030,2,0},
                         // Set point
                         {0x001E,2,0},
                         {0x0020,2,0},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         {0x0049,1,0},
                         {0xFFFF,0,0},
                         // Feedback
                         {0x0024,2,0},
                         {0x0026,2,0},
                         {0x0028,2,0},
                         {0x002A,1,0},
                         {0x002B,1,0},
                         {0xFFFF,0,0},
                         {0x0032,2,0},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0}};

TDynReg xl_reg[NUM_REG]={// Info
                         {0x0000,2,1},
                         {0xFFFF,0,0},
                         {0x0002,1,1},
                         {0x0003,1,1},
                         {0x0004,1,1},
                         {0x0005,1,1},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         {0x0011,1,1},
                         // Configuration
                         {0xFFFF,0,0},
                         {0x000B,1,1},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         {0x0006,2,1},
                         {0x0008,2,1},
                         {0x000C,1,1},
                         {0x000D,1,1},
                         {0x000E,1,1},
                         {0x000F,2,1},
                         {0x0023,2,0},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         // Status
                         {0x0012,1,1},
                         {0x0012,1,1},
                         {0x0019,1,0},
                         {0xFFFF,0,0},
                         {0x0031,1,0},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         {0x002F,1,0},
                         {0x0032,1,0},
                         // Control 
                         {0x0018,1,0},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         {0x001D,1,0},
                         {0x001C,1,0},
                         {0x001B,1,0},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         {0x0033,2,0},
                         // Set point
                         {0x001E,2,0},
                         {0x0020,2,0},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         {0x0049,1,0},
                         {0xFFFF,0,0},
                         // Feedback
                         {0x0025,2,0},
                         {0x0027,2,0},
                         {0x0029,2,0},
                         {0x002D,1,0},
                         {0x002E,1,0},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0}};

TDynReg mx_2_0_reg[NUM_REG]={// Info
                         {0x0000,2,1},
                         {0x0002,4,1},
                         {0x0006,1,1},
                         {0x0007,1,1},
                         {0x0008,1,1},
                         {0x0009,1,1},
                         {0x000C,1,1},
                         {0x000D,1,1},
                         {0x0044,1,0},
                         // Configuration
                         {0x000A,1,1},
                         {0x000B,1,1},
                         {0x0014,4,1},
                         {0x0018,4,1},
                         {0x0034,4,1},
                         {0x0030,4,1},
                         {0x001F,1,1},
                         {0x0022,2,1},
                         {0x0020,2,1},
                         {0x0024,2,1},
                         {0xFFFF,0,0},
                         {0x0026,2,1},
                         {0xFFFF,0,0},
                         {0x002C,4,1},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         // Status
                         {0x003F,1,1},
                         {0x003F,1,1},
                         {0x0041,1,0},
                         {0x0062,1,0},
                         {0x007A,1,0},
                         {0x007B,1,0},
                         {0xFFFF,0,0},
                         {0x0045,1,0},
                         {0x0046,1,0},
                         // Control 
                         {0x0040,1,0},
                         {0x004C,2,0},
                         {0x004E,2,0},
                         {0x0054,2,0},
                         {0x0052,2,0},
                         {0x0050,2,0},
                         {0x0058,2,0},
                         {0x005A,2,0},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         {0xFFFF,0,0},
                         // Set point
                         {0x0074,4,0},
                         {0x0068,4,0},
                         {0x0064,2,0},
                         {0x0066,2,0},
                         {0x006C,4,0},
                         {0x0070,4,0},
                         // Feedback
                         {0x0084,4,0},
                         {0x0080,4,0},
                         {0x007E,2,0},
                         {0x0090,2,0},
                         {0x0092,1,0},
                         {0x007C,2,0},
                         {0x0078,2,0},
                         {0x0088,5,0},
                         {0x008C,4,0}};

TServoConfig servo_data[NUM_SERVO_MODELS]={
//model | enc_res | gear | max_angle | center_angle | max_speed | cw_limit | ccw_limit | registers | pid | protocol
{300    , 1023    , 32   , 300<<7    , 150<<7       , 324       , 0        , 300<<7    , ax_reg    , 0   , 1},
{12     , 1023    , 254  , 300<<7    , 150<<7       , 354       , 0        , 300<<7    , ax_reg    , 0   , 1},
{18     , 1023    , 254  , 300<<7    , 150<<7       , 582       , 0        , 300<<7    , ax_reg    , 0   , 1},
{360    , 4095    , 32   , 360<<7    , 180<<7       , 2820      , 0        , 360<<7    , mx_1_0_reg, 1   , 1},
{29     , 4095    , 193  , 360<<7    , 180<<7       , 330       , 0        , 360<<7    , mx_1_0_reg, 1   , 1},
{310    , 4095    , 200  , 360<<7    , 180<<7       , 378       , 0        , 360<<7    , mx_1_0_reg, 1   , 1},
{320    , 4095    , 225  , 360<<7    , 180<<7       , 270       , 0        , 360<<7    , mx_1_0_reg, 1   , 1},
{30     , 4095    , 193  , 360<<7    , 180<<7       , 378       , 0        , 360<<7    , mx_2_0_reg, 1   , 2},
{311    , 4095    , 200  , 360<<7    , 180<<7       , 378       , 0        , 360<<7    , mx_2_0_reg, 1   , 2},
{321    , 4095    , 225  , 360<<7    , 180<<7       , 270       , 0        , 360<<7    , mx_2_0_reg, 1   , 2},
{350    , 1023    , 238  , 300<<7    , 150<<7       , 684       , 0        , 300<<7    , xl_reg    , 1   , 2}};
